Attribute VB_Name = "CheckInternetConnectionModule"
Option Explicit

Public Declare Function InternetGetConnectedState Lib "wininet.dll" (ByRef lpdwFlags As Long, ByVal dwReserved As Long) As Long
    
Public Const proxyConnection As Long = &H4
Public Const modemConnectionIsBusy As Long = &H8
Public Const internetIsOffline As Long = &H20
Public Const internetConnectionIsConfigured As Long = &H40
Public Const modemConnection As Long = &H1
Public Const rasInstalled As Long = &H10
Public Const lanConnection As Long = &H2

Public Function isLanConnection() As Boolean
    Dim dwFlags As Long
    Call InternetGetConnectedState(dwFlags, 0&)
    isLanConnection = dwFlags And lanConnection
End Function

Public Function isModemConnection() As Boolean
    Dim dwFlags As Long
    Call InternetGetConnectedState(dwFlags, 0&)
    isModemConnection = dwFlags And modemConnection
End Function

Public Function isProxyConnection() As Boolean
    Dim dwFlags As Long
    Call InternetGetConnectedState(dwFlags, 0&)
    isProxyConnection = dwFlags And proxyConnection
End Function

Public Function isConnected() As Boolean
    isConnected = InternetGetConnectedState(0&, 0&)
End Function

Public Function isRasInstalled() As Boolean
    Dim dwFlags As Long
    Call InternetGetConnectedState(dwFlags, 0&)
    isRasInstalled = dwFlags And rasInstalled
End Function
