VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmDialBakDialupServer 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DialBak Dial-Up Server"
   ClientHeight    =   4710
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5325
   Icon            =   "frmDialBakDialupServer.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   5325
   StartUpPosition =   2  'CenterScreen
   Visible         =   0   'False
   Begin VB.CommandButton cmdSettings 
      Caption         =   "&Settings"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   4080
      Width           =   4815
   End
   Begin VB.Timer tmrCheckNet 
      Enabled         =   0   'False
      Interval        =   60000
      Left            =   4680
      Top             =   0
   End
   Begin MSWinsockLib.Winsock iClients 
      Index           =   0
      Left            =   4200
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock wSock 
      Left            =   3720
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   9452
   End
   Begin MSWinsockLib.Winsock wsCheckNet 
      Left            =   3240
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Image trayNone 
      Height          =   240
      Left            =   2160
      Picture         =   "frmDialBakDialupServer.frx":628A
      Top             =   120
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Connection:"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   2760
      Width           =   855
   End
   Begin VB.Label connectionMethod 
      Height          =   255
      Left            =   1320
      TabIndex        =   7
      Top             =   2760
      Width           =   3735
   End
   Begin VB.Image trayNetwork 
      Height          =   240
      Left            =   2520
      Picture         =   "frmDialBakDialupServer.frx":63D4
      Top             =   120
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image trayModem 
      Height          =   240
      Left            =   2880
      Picture         =   "frmDialBakDialupServer.frx":651E
      Top             =   120
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Label serverStatus 
      Height          =   255
      Left            =   1320
      TabIndex        =   6
      Top             =   3120
      Width           =   3735
   End
   Begin VB.Label numClients 
      Height          =   255
      Left            =   1320
      TabIndex        =   5
      Top             =   3480
      Width           =   3735
   End
   Begin VB.Label serverIP 
      Height          =   255
      Left            =   1320
      TabIndex        =   4
      Top             =   2400
      Width           =   3735
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Server IP:"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   2400
      Width           =   855
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "# of Clients:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   3480
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Status:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   3120
      Width           =   855
   End
   Begin VB.Image Image1 
      Height          =   2085
      Left            =   240
      Picture         =   "frmDialBakDialupServer.frx":6668
      Top             =   120
      Width           =   4800
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      BorderStyle     =   6  'Inside Solid
      Index           =   1
      X1              =   240
      X2              =   5040
      Y1              =   3840
      Y2              =   3840
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000005&
      BorderWidth     =   2
      Index           =   0
      X1              =   255
      X2              =   5040
      Y1              =   3855
      Y2              =   3840
   End
End
Attribute VB_Name = "frmDialBakDialupServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private tmrProcessing As Boolean
Private wServerQuery As eServerQuery
Private wServerResponse As eServerResponse
Private rConnection As eConnection
Private blnFailedDialup As Boolean

Private Sub doExit()
    On Error Resume Next
    addToLog "DialBak Dial-Up Server shut down."
    RemoveFromTray
    Unload Me
    End
End Sub

Private Sub cmdSettings_Click()
    tmrCheckNet.Enabled = False
    frmSettings.Show vbModal, Me
    tmrCheckNet.Enabled = True
End Sub

Private Sub connectionMethod_Change()
    On Error Resume Next
    If blnLANConnected Then
        ModifyTray trayNetwork.Picture, getTrayText(), Me
    ElseIf blnModemConnected Then
        ModifyTray trayModem.Picture, getTrayText(), Me
    Else
        ModifyTray trayNone.Picture, getTrayText(), Me
    End If
End Sub

Private Sub Form_Load()
    On Error Resume Next
    If App.PrevInstance = True Then Unload Me: End
    App.TaskVisible = False
    dunConnection = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "dunConnection", "")
    strLogFile = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "strLogFile", "")
    tmrCheckNet.Interval = GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "checkInterval", 60000)
    lngRelayTimeout = GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "lngRelayTimeout", 30)
    strPrimaryServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "strPrimaryServer")
    strBackupServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "strBackupServer")
    strRelayServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Dial-Up Server", "strRelayServer")
    recordLog = (strLogFile <> "")
    blnIsBackup = (strPrimaryServer <> "")
    If dunConnection = "" Then
        MsgBox "You must set the dial-up connection to use before the DialBak Dial-Up Server can run. Click OK to set the dial-up connection.", vbOKOnly + vbInformation, "Dial-Up Connection"
        frmSettings.Show vbModal
        If dunConnection = "" Then Unload Me: End
    End If
    If dunConnectionExists(dunConnection) = False Then
        MsgBox "The dial-up connection '" & dunConnection & "' could not be found. Click OK to set a new dial-up connection.", vbOKOnly + vbInformation, "Dial-Up Connection Not Found"
        dunConnection = ""
        frmSettings.Show vbModal
        If dunConnection = "" Then Unload Me: End
    End If
    serverIP.Caption = wSock.LocalIP
    serverStatus.Caption = "Loading..."
    numClients.Caption = "0"
    wSock.Listen
    addToLog "DialBak Dial-Up Server started."
    AddToTray trayNone.Picture, getTrayText(), Me
    If LCase(Command()) <> "/startup" Then Me.Show
    wServerResponse = srNotInUse
    Call checkConnection
    tmrCheckNet.Enabled = True
    tmrCheckNet_Timer
    If blnLANConnected Then
        addToLog "Current Internet connection is via network."
    ElseIf blnModemConnected Then
        addToLog "Current Internet connection is via modem."
    Else
        addToLog "There is currently no active internet connection."
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    If RespondToTray(X) = 1 Then
        Me.WindowState = vbNormal
        Me.Show
        Me.SetFocus
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error Resume Next
    Cancel = 1
    If Me.Visible = True Then
        If MsgBox("Do you want to exit DialBak Dial-Up Server?", vbYesNo + vbQuestion, "Exit") = vbYes Then
            doExit
        End If
    Else
        doExit
    End If
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    If Me.WindowState = vbMinimized Then Me.Hide
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    For Each iClient In iClients
        iClient.Close
    Next
    wSock.Close
    DisconnectInternet
    RemoveFromTray
    End
End Sub

Private Sub iClients_Close(Index As Integer)
    On Error Resume Next
    iClients(Index).Close
    numClients.Caption = (iClients.Count - 2)
    Unload iClients(Index)
End Sub

Private Sub iClients_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    On Error Resume Next
    Dim iData As String
    iClients(Index).GetData iData
    Select Case iData
        Case "checkServer"
            iClients(Index).SendData "OK"
        Case "whatIsConnection"
            iClients(Index).SendData IIf(blnLANConnected, "connectionLAN", IIf(blnModemConnected, "connectionDialup", "connectionNone"))
        Case "updateServers"
            iClients(Index).SendData "OK"
            tmrCheckNet_Timer
    End Select
End Sub

Private Sub iClients_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    iClients_Close Index
End Sub

Private Sub tmrCheckNet_Timer()
    On Error Resume Next
    If tmrProcessing Then Exit Sub
    Dim rServerResponse As eRelayConnection
    Dim isLANConnected As Boolean
    tmrProcessing = True
    If blnIsBackup Then
        serverStatus.Caption = "Searching for primary server..."
        If isServerRunning(strPrimaryServer) Then
            serverStatus.Caption = "Idle - Primary Server Running"
            connectionMethod.Caption = ""
            ModifyTray Me.Icon, Me.Caption, Me
            If blnModemConnected Then internetDisconnect
            If (iClients.Count - 1) > 0 Then sendGlobalCommand "updateServers"
            tmrProcessing = False
            blnFailedDialup = False
            Exit Sub
        End If
        serverStatus.Caption = "Idle"
    Else
        If Len(strBackupServer) > 0 Then
            serverStatus.Caption = "Searching for backup server..."
            If isServerRunning(strBackupServer) Then
                serverStatus.Caption = "Checking backup server connection..."
                If isServerModemConnected(strBackupServer) Then
                    connectionMethod.Caption = ""
                    ModifyTray Me.Icon, Me.Caption, Me
                    serverStatus.Caption = "Terminating backup server connection..."
                    killServerConnection strBackupServer
                    serverStatus.Caption = "Waiting for backup server..."
                    tmrProcessing = False
                    blnFailedDialup = False
                    Exit Sub
                End If
            End If
        End If
    End If
    isLANConnected = blnLANConnected
    rServerResponse = checkConnection()
    If rServerResponse <> rcConnected And rServerResponse <> rcNotConnected Then
        addToLog "Relay server could not be contacted."
        tmrProcessing = False
        blnFailedDialup = False
        Exit Sub
    End If
    If blnModemConnected Or blnFailedDialup Then
        If rServerResponse = rcNotConnected Then
            If Not blnFailedDialup Then
                If isModemConnection() = False Then
                    sendGlobalCommand "netReconnect"
                    addToLog "Internet connection terminated unexpectedly. Reconnecting..."
                    internetDisconnect
                    If Not internetConnect() Then
                        addToLog "Dial-up connection failed. Retrying in " & CInt(tmrCheckNet.Interval / 1000) & " seconds..."
                        sendGlobalCommand "netConnectFail"
                        blnFailedDialup = True
                    Else
                        addToLog "Dial-up connection successfully re-established."
                        sendGlobalCommand "connectSuccess"
                        blnFailedDialup = False
                    End If
                End If
            End If
        Else
            sendGlobalCommand "networkReconnected"
            addToLog "Network internet connection has been re-established." & IIf(blnModemConnected, "Terminating modem connection...", "")
            internetDisconnect
            blnFailedDialup = False
        End If
    ElseIf isLANConnected Then
        If Not rServerResponse = rcConnected Then
            sendGlobalCommand "networkDisconnected"
            addToLog "Network internet connection has terminated. Connecting via modem..."
            If internetConnect() Then
                addToLog "Dial-up connection successfully established."
                sendGlobalCommand "connectSuccess"
                blnFailedDialup = False
            Else
                addToLog "Dial-up connection failed. Retrying in " & CInt(tmrCheckNet.Interval / 1000) & " seconds..."
                sendGlobalCommand "netConnectFail"
                blnFailedDialup = True
            End If
        End If
    Else
        If Not rServerResponse = rcConnected Then
            sendGlobalCommand "dialingUp"
            If internetConnect() Then
                addToLog "Dial-up connection successfully established."
                sendGlobalCommand "connectSuccess"
                blnFailedDialup = False
            Else
                addToLog "Dial-up connection failed. Retrying in " & CInt(tmrCheckNet.Interval / 1000) & " seconds..."
                sendGlobalCommand "netConnectFail"
                blnFailedDialup = True
            End If
        Else
            addToLog "Network internet connection established."
            sendGlobalCommand "connectionLAN"
            blnFailedDialup = False
        End If
    End If
    tmrProcessing = False
End Sub

Private Sub wsCheckNet_Connect()
    On Error Resume Next
    If wServerQuery = sqServerConnection Then
        wsCheckNet.SendData "whatIsConnection"
    ElseIf wServerQuery = sqBackupShutdown Then
        wsCheckNet.SendData "updateServers"
    ElseIf wServerQuery = sqRelayConnection Then
        wsCheckNet.SendData "checkConnection"
    ElseIf wServerQuery = sqNoQuery Then
        wServerResponse = srServerRunning
    End If
End Sub

Private Sub wsCheckNet_DataArrival(ByVal bytesTotal As Long)
    On Error Resume Next
    Dim iData As String
    wsCheckNet.GetData iData
    If wServerQuery = sqRelayConnection Then
        If iData = "True" Then
            wServerResponse = srRelayConnected
        ElseIf iData = "False" Then
            wServerResponse = srRelayDisconnected
        End If
    ElseIf wServerQuery = sqServerConnection Then
        If iData = "connectionDialup" Then
            wServerResponse = srConnectionDialup
        ElseIf iData = "connectionLAN" Then
            wServerResponse = srConnectionLAN
        ElseIf iData = "connectionNone" Then
            wServerResponse = srConnectionNone
        End If
    ElseIf wServerQuery = sqBackupShutdown Then
        wServerResponse = srServerRunning
    End If
End Sub

Private Sub wsCheckNet_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    wServerResponse = srErrorOccured
    wsCheckNet.Close
End Sub

Private Sub wSock_ConnectionRequest(ByVal requestID As Long)
    On Error Resume Next
    Dim lngSockID As Long
    If iClients.UBound > 0 Then
        For lngSockID = 1 To (iClients.UBound + 1)
            If isLoaded(iClients, lngSockID) = True Then
                If iClients(lngSockID).State = sckClosed Then
                    iClients(lngSockID).Accept requestID
                    Exit Sub
                End If
            Else
                Load iClients(lngSockID)
                iClients(lngSockID).Accept requestID
                numClients.Caption = (iClients.Count - 1)
                Exit Sub
            End If
        Next lngSockID
    Else
        Load iClients(1)
        iClients(1).Accept requestID
        numClients.Caption = (iClients.Count - 1)
    End If
End Sub

Private Function isLoaded(Object As Object, Index As Long) As Boolean
    On Error GoTo handleError
    Dim objName As String
    objName = Object(Index).Name
    isLoaded = True
    Exit Function
    
handleError:
    isLoaded = False
    Exit Function
End Function

Private Function sendGlobalCommand(strCommand As String)
    On Error Resume Next
    Dim lngSockID As Long
    If iClients.UBound > 0 Then
        For lngSockID = 1 To (iClients.UBound + 1)
            If isLoaded(iClients, lngSockID) = True Then
                If iClients(lngSockID).State = sckConnected Then
                    iClients(lngSockID).SendData strCommand
                End If
            End If
        Next lngSockID
    End If
End Function

Private Function internetConnect() As Boolean
    On Error Resume Next
    If dunConnectionExists(dunConnection) = False Then
        addToLog "The RAS connection '" & dunConnection & "' does not exist."
        internetConnect = False
        Exit Function
    End If
    Dim lngResult As Long
    Dim duTime As String
    Dim tmpConnectionSpeed
    serverStatus.Caption = "Dialing '" & dunConnection & "'..."
    addToLog serverStatus.Caption
    lngResult = InternetDial(Me.hwnd, dunConnection, INTERNET_DIAL_UNATTENDED, 0, 0)
    Select Case lngResult
        Case INTERNET_DIAL_RETURN_CONNECTED
            tmpConnectionSpeed = GetBinarySetting(HKEY_DYN_DATA, "PerfStats\StatData", "Dial-Up Adapter\ConnectSpeed")
            addToLog "Dial-up connection to '" & dunConnection & "' successfully established" & IIf(Len(Trim(CStr(tmpConnectionSpeed))) > 0, " at " & Trim(Format(tmpConnectionSpeed, "###,###,###,###")) & " bps.", ".")
            internetConnect = True
        Case INTERNET_DIAL_RETURN_NODIALTONE
            addToLog "An error occured while dialing: NO DIAL TONE"
            internetConnect = False
        Case INTERNET_DIAL_RETURN_BUSY
            addToLog "An error occured while dialing: LINE BUSY"
            internetConnect = False
        Case INTERNET_DIAL_RETURN_NORESPONSE
            addToLog "An error occured while dialing: REMOTE PARTY NOT RESPONDING"
            internetConnect = False
        Case INTERNET_DIAL_RETURN_BADAUTHENTICATION
            addToLog "An error occured while dialing: INVALID USER/PASSWORD"
            internetConnect = False
        Case INTERNET_DIAL_RETURN_USERCANCELLED
            addToLog "An error occured while dialing: ADMINISTRATOR CANCELLED DIAL-UP"
            internetConnect = False
        Case Else
            addToLog "An error occured while dialing: UNKNOWN ERROR " & lngResult
            internetConnect = False
    End Select
    serverStatus.Caption = "Idle"
    If internetConnect Then
        blnModemConnected = True
        connectionMethod.Caption = "Modem"
    Else
        blnModemConnected = False
        connectionMethod.Caption = IIf(blnLANConnected, "Network", "None")
    End If
End Function

Private Function internetDisconnect()
    On Error Resume Next
    DisconnectInternet
    blnModemConnected = False
    serverStatus.Caption = "Idle"
    connectionMethod.Caption = IIf(blnLANConnected, "Network", "None")
End Function

Public Function getTrayText() As String
    If blnLANConnected Or blnModemConnected Then
        getTrayText = Me.Caption & " - Connected via " & IIf(blnLANConnected, "Network", "Modem")
    Else
        getTrayText = Me.Caption & " - Not Connected"
    End If
End Function

Public Function isServerRunning(serverAddress) As Boolean
    On Error Resume Next
    If wServerResponse <> srNotInUse Then Exit Function
    Dim strStartTime As String
    strStartTime = Now()
    wServerQuery = sqNoQuery
    wServerResponse = srNoResponse
    wsCheckNet.Connect serverAddress, 9452
    Do Until ((wServerResponse <> srNoResponse) Or (CInt(Val(DateDiff("s", strStartTime, Now()))) >= 10))
        DoEvents
    Loop
    If wServerResponse = srServerRunning Then isServerRunning = True
    wsCheckNet.Close
    wServerResponse = srNotInUse
End Function

Public Function checkConnection() As eRelayConnection
    On Error Resume Next
    If wServerResponse <> srNotInUse Then Exit Function
    serverStatus.Caption = "Checking network connection..."
    connectionMethod.Caption = ""
    Dim strStartTime As String
    strStartTime = Now()
    wServerQuery = sqRelayConnection
    wServerResponse = srNoResponse
    wsCheckNet.Connect strRelayServer, 9451
    Do Until ((wServerResponse <> srNoResponse) Or (CLng(Val(DateDiff("s", strStartTime, Now())))) >= lngRelayTimeout)
        DoEvents
    Loop
    checkConnection = wServerResponse
    wsCheckNet.Close
    wServerResponse = srNotInUse
    serverStatus.Caption = "Idle"
    blnLANConnected = (checkConnection = rcConnected)
    Select Case checkConnection
        Case rcConnected
            connectionMethod.Caption = "Network"
        Case rcNotConnected
            connectionMethod.Caption = IIf(blnModemConnected, "Modem", "None")
        Case Else
            connectionMethod.Caption = IIf(blnModemConnected, "Modem", "Unknown")
    End Select
End Function

Public Function isServerModemConnected(strServer As String) As Boolean
    On Error Resume Next
    If wServerResponse <> srNotInUse Then Exit Function
    Dim strStartTime As String
    strStartTime = Now()
    wServerQuery = sqServerConnection
    wServerResponse = srNoResponse
    wsCheckNet.Connect strServer, 9452
    Do Until ((wServerResponse <> srNoResponse) Or (CLng(Val(DateDiff("s", strStartTime, Now())))) >= 10)
        DoEvents
    Loop
    isServerModemConnected = (wServerResponse = srConnectionDialup)
    wsCheckNet.Close
    wServerResponse = srNotInUse
End Function

Public Function killServerConnection(strServer As String)
    On Error Resume Next
    If wServerResponse <> srNotInUse Then Exit Function
    Dim strStartTime As String
    strStartTime = Now()
    wServerQuery = sqBackupShutdown
    wServerResponse = srNoResponse
    wsCheckNet.Connect strServer, 9452
    Do Until ((wServerResponse <> srNoResponse) Or (CLng(Val(DateDiff("s", strStartTime, Now())))) >= 10)
        DoEvents
    Loop
    wsCheckNet.Close
    wServerResponse = srNotInUse
End Function
