VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmResource 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   0  'None
   ClientHeight    =   645
   ClientLeft      =   105
   ClientTop       =   105
   ClientWidth     =   3045
   ControlBox      =   0   'False
   Icon            =   "frmResource.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   645
   ScaleWidth      =   3045
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin MSWinsockLib.Winsock checkServer 
      Left            =   600
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Timer tmrCheckServers 
      Interval        =   60000
      Left            =   1080
      Top             =   120
   End
   Begin MSWinsockLib.Winsock wS 
      Left            =   120
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      RemotePort      =   62194
   End
   Begin VB.Image traySwitch 
      Height          =   240
      Left            =   2640
      Picture         =   "frmResource.frx":628A
      Stretch         =   -1  'True
      Top             =   240
      Width           =   225
   End
   Begin VB.Image trayNetwork 
      Height          =   240
      Left            =   2280
      Picture         =   "frmResource.frx":6594
      Top             =   240
      Width           =   240
   End
   Begin VB.Image trayModem 
      Height          =   240
      Left            =   1920
      Picture         =   "frmResource.frx":66DE
      Top             =   240
      Width           =   240
   End
   Begin VB.Image trayDisconnected 
      Height          =   240
      Left            =   1560
      Picture         =   "frmResource.frx":6828
      Top             =   240
      Width           =   240
   End
   Begin VB.Menu mnuST 
      Caption         =   ""
      Visible         =   0   'False
      Begin VB.Menu mnuSTOptions 
         Caption         =   "Options"
      End
      Begin VB.Menu mnuSTExit 
         Caption         =   "Exit"
      End
   End
End
Attribute VB_Name = "frmResource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private blnReturnCheck As Boolean
Private tmrProcessing As Boolean
Private lngServerCheck As Long

Private Sub Form_Load()
    On Error Resume Next
    If App.PrevInstance Then Unload Me: End
    App.TaskVisible = False
    lngServerCheck = -1
    strPrimaryServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Monitor", "strPrimaryServer")
    strBackupServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Monitor", "strBackupServer")
    If strPrimaryServer = "" Then
        MsgBox "Before you can use DialBak Monitor, you must have entered at least the primary server. Please click OK and do so now.", vbOKOnly + vbInformation, "DialBak Monitor"
        frmOptions.Show vbModal
        If strPrimaryServer = "" Then
            Unload Me
            End
        End If
    End If
    AddToTray trayDisconnected.Picture, "DialBak Monitor - Loading...", Me
    tmrCheckServers_Timer
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    If RespondToTray(X) = 2 Then
        PopupMenu mnuST
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    wS.Close
    RemoveFromTray
End Sub

Private Sub mnuSTExit_Click()
    If MsgBox("Do you want to exit the DialBak Monitor?", vbYesNo + vbQuestion, "DialBak Monitor") = vbYes Then
        Unload Me
        End
    End If
End Sub

Private Sub mnuSTOptions_Click()
    frmOptions.Show
End Sub

Private Sub tmrCheckServers_Timer()
    On Error Resume Next
    If tmrProcessing Then Exit Sub
    tmrProcessing = True
    Dim strStartTime As String
    blnReturnCheck = False
    If tConnectedServer = scPrimary Then
        wS.SendData "checkServer"
        strStartTime = Now()
        Do Until ((blnReturnCheck) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
            DoEvents
        Loop
        If Not blnReturnCheck Then
            If Len(strBackupServer) > 0 Then
                ModifyTray traySwitch.Picture, "DialBak Monitor - Switching to backup...", Me
                ShowBubble "The primary server is not responding to a network request. DialBak Monitor is now attempting to connect to the backup server..."
                wS_Close
                tConnectingServer = scBackup
                wS.Connect strBackupServer, 9452
                strStartTime = Now()
                Do Until ((tConnectingServer = scNone) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
                    DoEvents
                Loop
                If tConnectedServer = scBackup Then
                    ModifyTray traySwitch.Picture, "DialBak Monitor - Requesting connection status...", Me
                    ShowBubble "DialBak Monitor has successfully connected to the backup server. Requesting connection status..."
                    wS.SendData "whatIsConnection"
                Else
                    ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
                    ShowBubble "DialBak Monitor has could not connect to any DialBak Dial-Up Server."
                End If
            Else
                ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
                ShowBubble "The primary server is not responding to a network request. DialBak Monitor has could not connect to any DialBak Dial-Up Server."
            End If
        End If
    ElseIf tConnectedServer = scBackup Then
        If isServerRunning(strPrimaryServer) Then
            ModifyTray traySwitch.Picture, "DialBak Monitor - Switching to primary server...", Me
            ShowBubble "The primary server is active. DialBak Monitor is disconnecting from the backup server and connecting to the primary server..."
            wS_Close
            strStartTime = Now()
            tConnectingServer = scPrimary
            wS.Connect strPrimaryServer, 9452
            Do Until ((tConnectingServer = scNone) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
                DoEvents
            Loop
            If tConnectedServer = scPrimary Then
                ModifyTray traySwitch.Picture, "DialBak Monitor - Requesting connection status...", Me
                ShowBubble "DialBak Monitor has successfully connected to the primary server. Requesting connection status..."
                wS.SendData "whatIsConnection"
            Else
                ShowBubble "DialBak Monitor has could not connect to any DialBak Dial-Up Server."
            End If
        Else
            blnReturnCheck = False
            wS.SendData "checkServer"
            strStartTime = Now()
            Do Until ((blnReturnCheck) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
                DoEvents
            Loop
            If Not blnReturnCheck Then
                ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
                ShowBubble "DialBak Monitor has could not connect to any DialBak Dial-Up Server."
            End If
        End If
    Else
        ModifyTray traySwitch.Picture, "DialBak Monitor - Connecting to server...", Me
        If isServerRunning(strPrimaryServer) Then
            ModifyTray traySwitch.Picture, "DialBak Monitor - Switching to primary server...", Me
            ShowBubble "The primary server is active. DialBak monitor is connecting to the primary server now..."
            wS_Close
            strStartTime = Now()
            tConnectingServer = scPrimary
            wS.Connect strPrimaryServer, 9452
            Do Until ((tConnectingServer = scNone) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
                DoEvents
            Loop
            If tConnectedServer = scPrimary Then
                ModifyTray traySwitch.Picture, "DialBak Monitor - Requesting connection status...", Me
                ShowBubble "DialBak Monitor has successfully connected to the primary server. Requesting connection status..."
                wS.SendData "whatIsConnection"
            Else
                ShowBubble "DialBak Monitor has could not connect to any DialBak Dial-Up Server."
            End If
        Else
            If Len(strBackupServer) > 0 Then
                If isServerRunning(strBackupServer) Then
                    ModifyTray traySwitch.Picture, "DialBak Monitor - Switching to backup server...", Me
                    ShowBubble "The backup server is active. DialBak Monitor is connecting to the backup server now..."
                    wS_Close
                    strStartTime = Now()
                    tConnectingServer = scBackup
                    wS.Connect strBackupServer, 9452
                    Do Until ((tConnectingServer = scNone) Or (CLng(DateDiff("s", strStartTime, Now())) >= 10))
                        DoEvents
                    Loop
                    If tConnectedServer = scBackup Then
                        ModifyTray traySwitch.Picture, "DialBak Monitor - Requesting connection status...", Me
                        ShowBubble "DialBak Monitor has successfully connected to the backup server. Requesting connection status..."
                        wS.SendData "whatIsConnection"
                    Else
                        ShowBubble "DialBak Monitor has could not connect to any DialBak Dial-Up Server."
                    End If
                Else
                    ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
                End If
            Else
                ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
            End If
        End If
    End If
    tmrProcessing = False
End Sub

Private Sub wS_Close()
    On Error Resume Next
    wS.Close
    ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
    tConnectedServer = scNone
    tConnectingServer = scNone
    tmrCheckServers_Timer
End Sub

Private Sub wS_Connect()
    tConnectedServer = tConnectingServer
    tConnectingServer = scNone
End Sub

Private Sub wS_DataArrival(ByVal bytesTotal As Long)
    On Error Resume Next
    Dim iData As String
    wS.GetData iData
    Select Case iData
        Case "netReconnect"
            tConnectionMethod = cmNone
            ModifyTray trayDisconnected.Picture, "DialBak Monitor - Dialing into the Internet...", Me
            ShowBubble "The dial-up internet connection was terminated. DialBak Dial-Up Server is re-dialing into the Internet..."
        Case "netConnectFail"
            tConnectionMethod = cmNone
            ModifyTray trayDisconnected.Picture, "DialBak Monitor - No Internet Connection", Me
            ShowBubble "DialBak Dial-Up Server could not dial into the Internet. There is currently no active internet connection."
        Case "connectSuccess"
            tConnectionMethod = cmModem
            ModifyTray trayModem.Picture, "DialBak Monitor - Internet Connected via Modem", Me
            ShowBubble "DialBak Dial-Up Server successfully connected to the internet via modem."
        Case "networkReconnected"
            tConnectionMethod = cmLAN
            ModifyTray trayNetwork.Picture, "DialBak Monitor - Internet Connected via Network", Me
            ShowBubble "The network internet connection has been re-established." & IIf((tConnectionMethod = cmModem), " DialBak Dial-Up Server is terminating the dial-up connection...", "")
        Case "networkDisconnected"
            tConnectionMethod = cmNone
            ModifyTray trayDisconnected.Picture, "DialBak Monitor - Dialing into the Internet...", Me
            ShowBubble "The network internet connection has terminated. DialBak Dial-Up Server is dialing into the Internet..."
        Case "connectionDialup"
            tConnectionMethod = cmModem
            ModifyTray trayModem.Picture, "DialBak Monitor - Connected via Modem", Me
            ShowBubble "The Internet is currently connected via modem."
        Case "connectionLAN"
            tConnectionMethod = cmLAN
            ModifyTray trayNetwork.Picture, "DialBak Monitor - Connected via Network", Me
            ShowBubble "The Internet is currently connected via network."
        Case "connectionNone"
            tConnectionMethod = cmNone
            ModifyTray trayDisconnected.Picture, "DialBak Monitor - Not Connected", Me
            ShowBubble "There is currently no connection to the Internet."
        Case "dialingUp"
            tConnectionMethod = cmNone
            ModifyTray trayDisconnected.Picture, "DialBak Monitor - Dialing into the Internet...", Me
            ShowBubble "The server is currently dialing into the Internet..."
        Case "updateServers"
            tmrCheckServers_Timer
        Case "OK"
            blnReturnCheck = True
    End Select
End Sub

Private Sub wS_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    wS.Close
    tConnectedServer = scNone
    If tConnectingServer <> scNone Then
        tConnectingServer = scNone
    Else
        ModifyTray trayDisconnected.Picture, "DialBak Monitor", Me
        tmrCheckServers_Timer
    End If
End Sub

Public Function ShowBubble(strStatusText As String)
    On Error Resume Next
    Load frmBubble
    frmBubble.serverName = ""
    frmBubble.connectionStatus = ""
    If tConnectedServer = scPrimary Then
        frmBubble.serverName = strPrimaryServer
    ElseIf tConnectedServer = scBackup Then
        frmBubble.serverName = strBackupServer
    Else
        frmBubble.serverName = "(not connected)"
    End If
    frmBubble.connectionStatus = strStatusText
    frmBubble.Show
    frmBubble.tmrHideMe.Enabled = True
End Function

Public Function isServerRunning(serverAddress) As Boolean
    On Error Resume Next
    If lngServerCheck > -1 Then Exit Function
    Dim strStartTime As String
    strStartTime = Now()
    lngServerCheck = 0
    checkServer.Connect serverAddress, 9452
    Do Until ((lngServerCheck <> 0) Or (CInt(Val(DateDiff("s", strStartTime, Now()))) >= 5))
        DoEvents
    Loop
    If lngServerCheck = 2 Then isServerRunning = True
    checkServer.Close
    lngServerCheck = -1
End Function

Private Sub checkServer_Connect()
    On Error Resume Next
    lngServerCheck = 2
End Sub

Private Sub checkServer_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    lngServerCheck = 1
    checkServer.Close
End Sub

