Attribute VB_Name = "modMain"
Public blnWasRunning As Boolean
Public blnControlService As Boolean
Public blnLogINet As Boolean
Public lngMinServers As Long
Public lngCheckInterval As Long
Public blnConnectionOK As Boolean
Public blnMailOnUp As String
Public strSMTPServer As String
Public strSMTPRecipient As String
Public strLocalIdentity As String
Public strDownStart As String
Public strDownFinish As String

Public Function addToLog(strData As String, Optional blnConnectionDown As Boolean, Optional blnConnectionUp As Boolean)
    On Error Resume Next
    If Not blnLogINet Then Exit Function
    Dim lngFreeFile As Long
    Dim strDownTime As String
    If blnConnectionDown <> False Or blnConnectionUp <> False Then
        If blnConnectionUp Then
            If blnConnectionOK Then
                Exit Function
            Else
                If blnWasRunning Then
                    blnConnectionOK = True
                    strDownFinish = Now()
                    strDownTime = FormatDuration(DateDiff("s", strDownStart, strDownFinish))
                    strData = Replace(strData, "%d", strDownTime)
                    If blnMailOnUp Then frmDialBakRelayServ.notifyUser strDownStart, strDownFinish, strDownTime
                    strDownStart = ""
                    strDownFinish = ""
                Else
                    blnWasRunning = True
                    blnConnectionOK = True
                End If
            End If
        Else
            If Not blnConnectionOK Then
                Exit Function
            Else
                blnConnectionOK = False
                strDownStart = Now()
            End If
        End If
    End If
    lngFreeFile = FreeFile()
    Open App.Path & "\inetLog.txt" For Append As #lngFreeFile
        Print #lngFreeFile, "[" & Format(Now(), "mm/dd/yyyy hh:mm:ss AM/PM") & "] " & strData
    Close #lngFreeFile
End Function

Public Function FormatDuration(lngSeconds As Long) As String
    Dim lngDays As Long
    Dim lngHours As Long
    Dim lngMinutes As Long
    Dim timeString As String
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds - (86400 * lngDays)
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds - (3600 * lngHours)
    lngMinutes = Int(lngSeconds / 60)
    lngSeconds = lngSeconds - (60 * lngMinutes)
    If lngDays > 0 Then timeString = timeString & lngDays & " day" & IIf(lngDays > 1, "s", "") & " "
    If lngHours > 0 Then timeString = timeString & lngHours & " hour" & IIf(lngHours > 1, "s", "") & " "
    If lngMinutes > 0 Then timeString = timeString & lngMinutes & " minute" & IIf(lngMinutes > 1, "s", "") & " "
    If lngSeconds > 0 Then timeString = timeString & lngSeconds & " second" & IIf(lngSeconds > 1, "s", "") & " "
    FormatDuration = Trim(timeString)
End Function
