VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmDialBakRelayServ 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DialBak Relay Server"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5265
   Icon            =   "dialBakRelayServ.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   5265
   StartUpPosition =   2  'CenterScreen
   Visible         =   0   'False
   Begin MSWinsockLib.Winsock sckSMTP 
      Left            =   4200
      Top             =   480
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Timer tmrSendMail 
      Enabled         =   0   'False
      Interval        =   60000
      Left            =   4680
      Top             =   960
   End
   Begin VB.Timer tmrCheckConnection 
      Enabled         =   0   'False
      Left            =   4680
      Top             =   480
   End
   Begin VB.CommandButton cmdSettings 
      Caption         =   "&Settings"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   3840
      Width           =   4815
   End
   Begin MSWinsockLib.Winsock iClients 
      Index           =   0
      Left            =   4680
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock wSock 
      Left            =   4200
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   9451
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      BorderStyle     =   6  'Inside Solid
      Index           =   1
      X1              =   240
      X2              =   5040
      Y1              =   3600
      Y2              =   3600
   End
   Begin VB.Image trayDisconnected 
      Height          =   240
      Left            =   3480
      Picture         =   "dialBakRelayServ.frx":628A
      Top             =   0
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image trayConnected 
      Height          =   240
      Left            =   3840
      Picture         =   "dialBakRelayServ.frx":63D4
      Top             =   0
      Visible         =   0   'False
      Width           =   240
   End
   Begin dialBakRelayServer.ctlService serviceController 
      Left            =   0
      Top             =   0
      _ExtentX        =   873
      _ExtentY        =   873
   End
   Begin VB.Label serverStatus 
      Height          =   255
      Left            =   1320
      TabIndex        =   6
      Top             =   3120
      Width           =   3735
   End
   Begin VB.Label numClients 
      Height          =   255
      Left            =   1320
      TabIndex        =   5
      Top             =   2760
      Width           =   3735
   End
   Begin VB.Label serverIP 
      Height          =   255
      Left            =   1320
      TabIndex        =   4
      Top             =   2400
      Width           =   3735
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Server IP:"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   2400
      Width           =   855
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "# of Clients:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   2760
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Status:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   3120
      Width           =   855
   End
   Begin VB.Image Image1 
      Height          =   2085
      Left            =   240
      Picture         =   "dialBakRelayServ.frx":651E
      Top             =   120
      Width           =   4800
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000005&
      BorderWidth     =   2
      Index           =   0
      X1              =   255
      X2              =   5040
      Y1              =   3615
      Y2              =   3600
   End
End
Attribute VB_Name = "frmDialBakRelayServ"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private isChecking As Boolean
Private blnIsConnected As Boolean
Private tmpMessageHeader As String
Private tmpMessageBody As String
Private smtpState As SMTP_State
Private blnIsRunning As Boolean

Private Sub isExit()
    On Error Resume Next
    If MsgBox("Do you want to exit DialBak Relay Server?", vbYesNo + vbQuestion, "Exit") = vbYes Then
        RemoveFromTray
        Unload Me
        End
    End If
End Sub

Private Sub cmdSettings_Click()
    tmrCheckConnection.Enabled = False
    frmSettings.Show vbModal, Me
    tmrCheckConnection.Enabled = True
End Sub

Private Sub Form_Load()
    If App.PrevInstance = True Then Unload Me: End
    App.TaskVisible = False
    blnControlService = CBool(GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server", "controlService"))
    lngMinServers = GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server", "lngMinServers", 1)
    lngCheckInterval = GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server", "lngCheckInterval", 60)
    blnLogINet = CBool(GetSettingLong(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server", "logInternet"))
    blnMailOnUp = (GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server\Notify", "") = "-1")
    strSMTPServer = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server\Notify", "smtpServer")
    strSMTPRecipient = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server\Notify", "sendTo")
    strLocalIdentity = GetSettingString(HKEY_LOCAL_MACHINE, "Software\PCSCT Software\DialBak\Relay Server\Notify", "localID")
    serverIP.Caption = wSock.LocalIP
    numClients.Caption = "0"
    AddToTray trayDisconnected.Picture, "DialBak Relay Server - Loading...", Me
    wSock.Listen
    tmrCheckConnection.Interval = (lngCheckInterval * 1000)
    If LCase(Command()) <> "/startup" Then Me.Show
    addToLog "DialBak Relay Server started."
    blnIsConnected = CheckConnection
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    If RespondToTray(X) = 1 Then
        If Me.WindowState = vbMinimized Then Me.WindowState = vbNormal
        Me.Show
        Me.SetFocus
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> 1 Then
        If Me.Visible = True Then
            Cancel = 1
            isExit
        Else
            RemoveFromTray
            Unload frmClientMonitor
            Unload Me
            End
        End If
    End If
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    If Me.WindowState = vbMinimized Then Me.Hide
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    wSock.Close
    RemoveFromTray
    End
End Sub

Private Sub iClients_Close(Index As Integer)
    On Error Resume Next
    iClients(Index).Close
    Unload iClients(Index)
    numClients.Caption = (iClients.Count - 1)
End Sub

Private Sub iClients_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    On Error Resume Next
    Dim iData As String
    iClients(Index).GetData iData
    Select Case iData
        Case "checkConnection"
            iClients(Index).SendData GetConnectionState()
    End Select
End Sub

Private Function GetConnectionState() As String
    On Error Resume Next
    If isChecking Then
        Do Until Not isChecking: DoEvents: Loop
        GetConnectionState = CStr(blnIsConnected)
    Else
        GetConnectionState = CStr(blnIsConnected)
    End If
End Function

Private Sub iClients_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    iClients_Close Index
End Sub

Private Sub tmrCheckConnection_Timer()
    blnIsConnected = CheckConnection
End Sub

Private Sub tmrSendMail_Timer()
    tmrSendMail.Enabled = False
    SendMail
End Sub

Private Sub wSock_ConnectionRequest(ByVal requestID As Long)
    On Error Resume Next
    Dim lngSockID As Long
    If iClients.UBound > 0 Then
        For lngSockID = 1 To (iClients.UBound + 1)
            If isLoaded(iClients, lngSockID) = True Then
                If iClients(lngSockID).State = sckClosed Then
                    iClients(lngSockID).Accept requestID
                    Exit Sub
                End If
            Else
                Load iClients(lngSockID)
                iClients(lngSockID).Accept requestID
                numClients.Caption = (iClients.Count - 1)
                Exit Sub
            End If
        Next lngSockID
    Else
        Load iClients(1)
        iClients(1).Accept requestID
        numClients.Caption = (iClients.Count - 1)
    End If
End Sub

Private Function isLoaded(Object As Object, Index As Long) As Boolean
    On Error GoTo handleError
    Dim objName As String
    objName = Object(Index).Name
    isLoaded = True
    Exit Function
    
handleError:
    isLoaded = False
    Exit Function
End Function

Public Function CheckConnection() As Boolean
    On Error Resume Next
    tmrCheckConnection.Enabled = False
    isChecking = True
    serverStatus.Caption = "Checking connection..."
    serverStatus.Refresh
    On Error GoTo handleError
    Dim lngFreeFile As String
    Dim strInput As String
    Dim intResponded As Integer
    lngFreeFile = FreeFile()
    Open App.Path & "\pingSites.dat" For Input As #lngFreeFile
        Do Until (EOF(lngFreeFile))
            Input #lngFreeFile, strInput
            serverStatus.Caption = "Checking site " & strInput & "..."
            serverStatus.Refresh
            If DoPing(strInput) = 0 Then
                intResponded = intResponded + 1
            End If
        Loop
    Close #lngFreeFile
    On Error Resume Next
    CheckConnection = (intResponded >= lngMinServers)
    serverStatus.Caption = IIf(CheckConnection, "Connected", "Disconnected")
    ModifyTray IIf(CheckConnection, trayConnected.Picture, trayDisconnected.Picture), "DialBak Relay Server - " & IIf(CheckConnection, "Connected", "Disconnected"), Me
    If blnControlService Then
        If intResponded >= lngMinServers Then
            serviceController.ServiceName = "DNS2GoClient"
            serviceController.StartService
        Else
            serviceController.ServiceName = "DNS2GoClient"
            serviceController.StopService
        End If
    End If
    If blnIsRunning Then
        If blnLogINet Then
            If intResponded >= lngMinServers Then
                addToLog "Internet connection re-established.", False, True
            Else
                addToLog "Internet connection terminated.", True, False
            End If
        End If
    Else
        blnIsRunning = True
        If blnLogINet Then
            If intResponded >= lngMinServers Then
                addToLog "Internet connection is active.", False, True
            Else
                addToLog "Internet connection is inactive.", True, False
            End If
        End If
    End If
    tmrCheckConnection.Enabled = True
    isChecking = False
    Exit Function
    
handleError:
    On Error Resume Next
    Close
    CheckConnection = False
    ModifyTray IIf(CheckConnection, trayConnected.Picture, trayDisconnected.Picture), "DialBak Relay Server - " & IIf(CheckConnection, "Connected", "Disconnected"), Me
    serverStatus.Caption = "Error reading sites list"
    isChecking = False
    Exit Function
End Function

Public Function notifyUser(strDownStart As String, strDownFinish As String, strDownTime As String)
    On Error Resume Next
    tmpMessageHeader = "DATE: " & Format(Now(), "mm/dd/yyyy hh:mm:ss AM/PM") & vbCrLf & "FROM: DialBak - [" & strLocalIdentity & "] <" & strSMTPRecipient & ">" & vbCrLf & "TO: <" & strSMTPRecipient & ">" & vbCrLf & "SUBJECT: Internet Connection Interruption"
    tmpMessageBody = tmpMessageBody & _
                     "An internet interruption has occured. The information is as follows:" & vbCrLf & vbCrLf & _
                     "The connection terminated at: " & strDownStart & vbCrLf & _
                     "The connection was re-established at: " & strDownFinish & vbCrLf & _
                     "The internet was down for: " & strDownTime & vbCrLf & vbCrLf & vbCrLf & vbCrLf & _
                     "-------------------------------------------------------------------" & vbCrLf & _
                     "This message was automatically generated by" & vbCrLf & _
                     "DialBak Relay Server 1.2" & vbCrLf & _
                     "Copyright  2002 PCSCT Software. All rights reserved." & vbCrLf & vbCrLf & _
                     "-------------------------------------------------------------------" & vbCrLf & vbCrLf
    SendMail
End Function

Private Function SendMail()
    On Error GoTo handleError
    sckSMTP.Close
    smtpState = SMTP_Connecting
    sckSMTP.Connect strSMTPServer, 25
    Exit Function
    
handleError:
    sckSMTP.Close
    tmrSendMail.Enabled = True
End Function

Private Sub sckSMTP_Close()
    On Error Resume Next
    sckSMTP.Close
    smtpState = SMTP_Closed
End Sub

Private Sub sckSMTP_DataArrival(ByVal bytesTotal As Long)
    On Error Resume Next
    Dim iData As String
    Dim strBuffer As String
    sckSMTP.GetData iData
    Select Case Val(Mid$(iData, 1, 3))
        Case 220
            smtpState = SMTP_Identifying
            sckSMTP.SendData "HELO " & GetUserName(strSMTPRecipient) & vbCrLf
        Case 250
            Select Case smtpState
                Case SMTP_Identifying
                    smtpState = SMTP_MailFrom
                    sckSMTP.SendData "MAIL FROM: <" & strSMTPRecipient & ">" & vbCrLf
                Case SMTP_MailFrom
                    smtpState = SMTP_RcptTo
                    sckSMTP.SendData "RCPT TO: <" & strSMTPRecipient & ">" & vbCrLf
                Case SMTP_RcptTo
                    smtpState = SMTP_BeginBody
                    sckSMTP.SendData "DATA" & vbCrLf
                Case SMTP_SendBody
                    smtpState = SMTP_Closing
                    sckSMTP.SendData "QUIT"
                    sckSMTP.Close
                    smtpState = SMTP_Closed
            End Select
        Case 251
            Select Case smtpState
                Case SMTP_RcptTo
                    smtpState = SMTP_BeginBody
                    sckSMTP.SendData "DATA" & vbCrLf
            End Select
        Case 354
            Select Case smtpState
                Case SMTP_BeginBody
                    smtpState = SMTP_SendBody
                    sckSMTP.SendData tmpMessageHeader & vbCrLf & vbCrLf & tmpMessageBody & vbCrLf & "." & vbCrLf
                    tmpMessageHeader = ""
                    tmpMessageBody = ""
            End Select
        Case Is >= 400
            tmrSendMail.Enabled = True
            smtpState = SMTP_Closed
            sckSMTP.Close
        Case Else
            tmrSendMail.Enabled = True
            smtpState = SMTP_Closed
            sckSMTP.Close
    End Select
End Sub

Private Function GetUserName(strAddress As String) As String
    On Error Resume Next
    If InStr(1, strAddress, "@") > 0 Then
        GetUserName = Mid(strAddress, 1, InStr(1, strAddress, "@") - 1)
    Else
        GetUserName = strAddress
    End If
End Function

Private Sub sckSMTP_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error Resume Next
    sckSMTP.Close
    smtpState = SMTP_Closed
    tmrSendMail.Enabled = True
End Sub
